import { Comparator } from '../types';
export interface BinarySearchTree<T> {
    insert(element: T): void;
    remove(element: T): void;
    find(element: T): boolean;
    min(): T | undefined;
    max(): T | undefined;
    forEach(callback: (element: T) => void, traversal?: 'inorder' | 'preorder' | 'postorder'): void;
    isEmpty(): boolean;
    clear(): void;
    count(): number;
}
export declare class BinarySearchTree<T> implements BinarySearchTree<T> {
    private root;
    private comparator;
    constructor(comparator?: Comparator<T>);
    private removeNode;
    private findMin;
    private isEqual;
    private inorderTraversal;
    private preorderTraversal;
    private postorderTraversal;
    private countNodes;
}
