export interface LinkedList<T> {
    pushBack(element: T): void;
    pushFront(element: T): void;
    popBack(): T | undefined;
    popFront(): T | undefined;
    front(): T | undefined;
    back(): T | undefined;
    insert(element: T, position: number): boolean;
    insertBefore(element: T, condition: (element: T) => boolean): boolean;
    insertAfter(element: T, condition: (element: T) => boolean): boolean;
    removeIf(condition: (element: T) => boolean): boolean;
    removeAt(position: number): T | undefined;
    forEach(callback: (element: T) => void): void;
    get(position: number): T | undefined;
    isEmpty(): boolean;
    size(): number;
    clear(): void;
}
export declare class LinkedList<T> implements LinkedList<T> {
    private head;
    private tail;
    private length;
    constructor();
}
