import { Comparator } from '../types';
export interface RedBlackTree<K, V> {
    insert(key: K, value: V): void;
    remove(key: K): void;
    find(key: K): V | undefined;
    min(): V | undefined;
    max(): V | undefined;
    forEach(callback: (key: K, value: V) => void): void;
    isEmpty(): boolean;
    size(): number;
    clear(): void;
}
export declare class RedBlackTree<K, V> implements RedBlackTree<K, V> {
    private root;
    private nodeCount;
    private comparator;
    constructor(comparator?: Comparator<K>);
    private rotateLeft;
    private rotateRight;
    private fixInsert;
    private findNode;
    private findMinNode;
    private findMaxNode;
    private deleteNode;
    private transplant;
    private fixDelete;
    private isEqual;
    private inorderTraversal;
}
