"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Stack = void 0;
class Stack {
    items;
    constructor() {
        this.items = [];
    }
    /**
     * Adds an element to the top of the stack.
     */
    push(element) {
        this.items.push(element);
    }
    /**
     * Removes and returns the top element from the stack, or undefined if stack is empty.
     */
    pop() {
        return this.items.pop();
    }
    /**
     * Returns the top element of the stack without removing it, or undefined if stack is empty.
     */
    top() {
        return this.items[this.items.length - 1];
    }
    /**
     * Checks if the stack is empty. Returns true if the stack is empty, false otherwise.
     */
    isEmpty() {
        return this.items.length === 0;
    }
    /**
     * Returns the number of elements in the stack. The size of the stack
     */
    size() {
        return this.items.length;
    }
    /**
     * Removes all elements from the stack.
     */
    clear() {
        this.items = [];
    }
}
exports.Stack = Stack;
//# sourceMappingURL=stack.js.map